Index: SQLBuilderBase.java
===================================================================
--- SQLBuilderBase.java	(revision 44197)
+++ SQLBuilderBase.java	(revision 44198)
@@ -2532,650 +2234,211 @@
         }
     }
 
+    protected ExpressionBuilder expressionBuilder;
 
-    private static class ParametersBase extends ArrayList<Parameter> implements Parameters {
+    protected String defaultSchema;
+    protected boolean supportSchemas;
+    protected boolean hasSpatialFunctions;
+    protected GeometrySupportType geometrySupportType;
+    protected boolean allowAutomaticValues;
 
-        private static final long serialVersionUID = -2188534574151780470L;
+    private static Map<Pair<Integer, Integer>, String> sqlgeometrytypes = null;
 
-        public ParametersBase() {
-            super();
-        }
+    protected String constant_true = "(1=1)";
+    protected String constant_false = "(1=1)";
 
-        public ParametersBase(Collection parameters) {
-            super(parameters);
-        }
+    protected String type_boolean = "BOOLEAN";
+    protected String type_byte = "TINYINT";
+    protected String type_bytearray = "BYTEA";
+    protected String type_geometry = "TEXT";
+    protected String type_char = "CHARACTER(1)";
+    protected String type_date = "DATE";
+    protected String type_double = "DOUBLE PRECISION"; //float con 53 bits de mantisa, float(54)
+    protected String type_numeric_p = "NUMERIC({0})";
+    protected String type_numeric_ps = "NUMERIC({0},{1})";
+    protected String type_bigdecimal = "NUMERIC({0},{1})";
+    protected String type_float = "REAL"; //float con 24 bits de mantisa, float(24)
+    protected String type_int = "INT";
+    protected String type_long = "BIGINT";
+    protected String type_string = "TEXT";
+    protected String type_string_p = "VARCHAR({0})";
+    protected String type_time = "TIME";
+    protected String type_timestamp = "TIMESTAMP";
+    protected String type_version = "VARCHAR(30)";
+    protected String type_URI = "TEXT";
+    protected String type_URL = "TEXT";
+    protected String type_FILE = "TEXT";
+    protected String type_FOLDER = "TEXT";
 
-        @Override
-        public Parameter get(String name) {
-            if( name == null ) {
-                return null;
-            }
-            for (Parameter param : this) {
-                if( param.is_variable() || param.is_geometry_variable() ) {
-                    if( name.equalsIgnoreCase(param.getName()) ) {
-                        return param;
-                    }
-                }
-            }
-            return null;
-        }
+    protected String STMT_DELETE_FROM_table_WHERE_expresion = "DELETE FROM {0} WHERE {1}";
+    protected String STMT_DELETE_FROM_table = "DELETE FROM {0}";
+    protected String STMT_INSERT_INTO_table_columns_VALUES_values = "INSERT INTO {0} ( {1} ) VALUES ( {2} )";
+    protected String STMT_UPDATE_TABLE_STATISTICS_table = "VACUUM ANALYZE {0}";
+    protected String STMT_DROP_TABLE_table = "DROP TABLE {0}";
+    protected String STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table = "DELETE FROM GEOMETRY_COLUMNS WHERE f_table_schema = {0} AND f_table_name = {1}";
+    protected String STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_table = "DELETE FROM GEOMETRY_COLUMNS WHERE f_table_name = {0}";
+    protected String STMT_UPDATE_table_SET_columnsAndValues_WHERE_expresion = "UPDATE {0} SET {1} WHERE {2}";
+    protected String STMT_UPDATE_table_SET_columnsAndValues = "UPDATE {0} SET {1}";
+    protected String STMT_GRANT_privileges_ON_table_TO_role = "GRANT {0} ON {1} TO {2}";
 
-        
-        @Override
-        public String toString() {
-            boolean first = true;
-            StringBuilder builder = new StringBuilder();
-            builder.append("{ ");
-            for (Parameter param : this) {
-                if (!first) {
-                    builder.append(", ");
-                } else {
-                    first = false;
-                }
-                String s;
-                Object value = param.getValue();
-                if (value == null) {
-                    s = "null";
-                } else if (value instanceof String) {
-                    s = "'" + (String) value + "'";
-                } else {
-                    s = value.toString();
-                }
-                switch (param.getType()) {
-                    case Constant:
-                        builder.append(s);
-                        break;
-                    case Geometry:
-                        builder.append("(Geometry)");
-                    case Variable:
-                    default:
-                        builder.append(param.getName());
-                        builder.append(": ");
-                        builder.append(s);
-                }
-            }
-            builder.append(" }");
-            return builder.toString();
-        }
-    }
-
-    protected Value value;
-    protected Config config;
-  
     public SQLBuilderBase() {
-        
-        this.config = new ConfigBase();
-        this.value = null;
-        
-        config.set(SQLConfig.has_spatial_functions, false);
-        config.set(SQLConfig.support_schemas, true);
-        config.set(SQLConfig.constant_true, "(1=1)");
-        config.set(SQLConfig.constant_false, "(1=2)");
-        config.set(SQLConfig.quote_for_identifiers, "\"");
-        config.set(SQLConfig.quote_for_strings, "'");
-        config.set(SQLConfig.geometry_type_support, GeometrySupportType.WKT);
-        config.set(SQLConfig.group, "( {0} )");
+        this.expressionBuilder = ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
 
-        config.set(SQLConfig.ST_SRID, "ST_SRID({0})");
-        config.set(SQLConfig.ST_AsText, "ST_AsText({0})");
-        config.set(SQLConfig.ST_AsBinary, "ST_AsBinary({0})");
-        config.set(SQLConfig.ST_AsEWKB, "ST_AsEWKB({0})");
-        config.set(SQLConfig.ST_Contains, "ST_Contains(({0}), ({1}))");
-        config.set(SQLConfig.ST_Crosses, "ST_Crosses(({0}), ({1}))");
-        config.set(SQLConfig.ST_Disjoint, "ST_Disjoint(({0}), ({1}))");
-        config.set(SQLConfig.ST_Equals, "ST_Equals(({0}), ({1}))");
-        config.set(SQLConfig.ST_IsClosed, "ST_IsClosed({0})");
-        config.set(SQLConfig.ST_Overlaps, "ST_Overlaps(({0}), ({1}))");
-        config.set(SQLConfig.ST_Touches, "ST_Touches(({0}), ({1}))");
-        config.set(SQLConfig.ST_Within, "ST_Within(({0}), ({1}))");
-        config.set(SQLConfig.ST_Envelope, "ST_Envelope({0})");
-        config.set(SQLConfig.ST_Intersects, "ST_Intersects(({0}), ({1}))");
-        config.set(SQLConfig.ST_GeomFromText, "ST_GeomFromText({0}, ({1}))");
-        config.set(SQLConfig.ST_GeomFromWKB, "ST_GeomFromWKB(({0}), ({1}))");
-        config.set(SQLConfig.ST_GeomFromEWKB, "ST_GeomFromEWKB(({0}), ({1}))");
+        this.hasSpatialFunctions = false;
+        this.supportSchemas = true;
+        this.geometrySupportType = GeometrySupportType.WKT;
 
-        // Por defecto no esta disponible la funcion ST_Simplify
-        // El proveedor que la soporte que la defina.
-        // config.set(SQLConfig.ST_Simplify, "ST_Simplify(({0}), ({1}))");
-        config.remove_functionality(SQLConfig.ST_Simplify);
+        this.defaultSchema = "public";
+        this.allowAutomaticValues = true;
 
-        config.set(SQLConfig.lcase, "LCASE({0})");
-        config.set(SQLConfig.ucase, "UCASE({0})");
-        config.set(SQLConfig.isNull, "( ({0}) IS NULL )");
-        config.set(SQLConfig.notIsNull, "( ({0}) NOT IS NULL )");
-        config.set(SQLConfig.operator_not, "( NOT ({0}) )");
-
-        config.set(SQLConfig.operator_AND, "{0} AND {1}");
-        config.set(SQLConfig.operator_OR, "{0} OR {1}");
-        config.set(SQLConfig.operator_EQ, "( ({0}) = ({1}) )");
-        config.set(SQLConfig.operator_NE, "( ({0}) <> ({1}) )");
-        config.set(SQLConfig.operator_GT, "( ({0}) > ({1}) )");
-        config.set(SQLConfig.operator_GE, "( ({0}) >= ({1}) )");
-        config.set(SQLConfig.operator_LT, "( ({0}) < ({1}) )");
-        config.set(SQLConfig.operator_LE, "( ({0}) <= ({1}) )");
-        config.set(SQLConfig.operator_LIKE, "( ({0}) LIKE ({1}) )");
-        config.set(SQLConfig.operator_ILIKE, "( ({0}) ILIKE ({1}) )");
-
-        config.set(SQLConfig.operator_add, "{0} + {1}");
-        config.set(SQLConfig.operator_subst, "{0} - {1}");
-        config.set(SQLConfig.operator_mult, "{0} * {1}");
-        config.set(SQLConfig.operator_div, "{0} / {1}");
-        config.set(SQLConfig.operator_concat, "{0} || {1}");
-
-
-        config.set(SQLConfig.default_schema, "public");
-        config.set(SQLConfig.allowAutomaticValues, true);
-        
-        config.set(SQLConfig.ST_ExtentAggregate, "ST_Extent({0})");
-        config.set(SQLConfig.ST_UnionAggregate, "ST_Union({0})");
-        config.set(SQLConfig.count, "COUNT({0})");
-        config.set(SQLConfig.count_distinct, "COUNT(DISTINCT {0})");
-
-        config.set(SQLConfig.type_boolean, "BOOLEAN");
-        config.set(SQLConfig.type_byte, "TINYINT");
-        config.set(SQLConfig.type_bytearray, "BYTEA");
-        config.set(SQLConfig.type_geometry, "TEXT");
-        config.set(SQLConfig.type_char, "CHARACTER(1)");
-        config.set(SQLConfig.type_date, "DATE");
-        config.set(SQLConfig.type_double, "DOUBLE PRECISION"); //float con 53 bits de mantisa, float(54)
-        config.set(SQLConfig.type_numeric_p, "NUMERIC({0})");
-        config.set(SQLConfig.type_numeric_ps, "NUMERIC({0},{1})");
-        config.set(SQLConfig.type_bigdecimal, "NUMERIC({0},{1})");
-        config.set(SQLConfig.type_float, "REAL"); //float con 24 bits de mantisa, float(24)
-        config.set(SQLConfig.type_int, "INT");
-        config.set(SQLConfig.type_long, "BIGINT");
-        config.set(SQLConfig.type_string, "TEXT");
-        config.set(SQLConfig.type_string_p, "VARCHAR({0})");
-        config.set(SQLConfig.type_time, "TIME");
-        config.set(SQLConfig.type_timestamp, "TIMESTAMP");
-        config.set(SQLConfig.type_version, "VARCHAR(30)");
-        config.set(SQLConfig.type_URI, "TEXT");
-        config.set(SQLConfig.type_URL, "TEXT");
-        config.set(SQLConfig.type_FILE, "TEXT");
-        config.set(SQLConfig.type_FOLDER, "TEXT");
-
-        config.set(SQLConfig.DELETE_FROM_table_WHERE_expresion, "DELETE FROM {0} WHERE {1}");
-        config.set(SQLConfig.DELETE_FROM_table, "DELETE FROM {0}");
-        config.set(SQLConfig.INSERT_INTO_table_columns_VALUES_values, "INSERT INTO {0} ( {1} ) VALUES ( {2} )");
-        config.set(SQLConfig.UPDATE_TABLE_STATISTICS_table, "VACUUM ANALYZE {0}");
-        config.set(SQLConfig.DROP_TABLE_table, "DROP TABLE {0}");
-        config.set(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table, "DELETE FROM GEOMETRY_COLUMNS WHERE f_table_schema = {0} AND f_table_name = {1}");
-        config.set(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_table, "DELETE FROM GEOMETRY_COLUMNS WHERE f_table_name = {0}");
-        config.set(SQLConfig.UPDATE_table_SET_columnsAndValues_WHERE_expresion, "UPDATE {0} SET {1} WHERE {2}");
-        config.set(SQLConfig.UPDATE_table_SET_columnsAndValues, "UPDATE {0} SET {1}");
-        config.set(SQLConfig.GRANT_privileges_ON_table_TO_role, "GRANT {0} ON {1} TO {2}");        
     }
-   
+    
     @Override
-    public ExpressionBuilder createExpressionBuilder() {
-        return ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
+    public void setProperties(Class filter, final Object... values) {
+        this.accept(new Visitor() {
+            @Override
+            public void visit(Visitable v) {
+                for (int i = 0; i < values.length; i+=2) {
+                    ((Value)v).setProperty((String) values[i], values[i+1]);
+                }
+            }
+        }, new ClassVisitorFilter(filter) );
     }
 
-    @Override
-    public Config getConfig() {
-        return this.config;
+    public String quote_for_identifiers() {
+        return "\"";
     }
 
-    @Override
-    public Value getValue() {
-        return this.value;
+    public String quote_for_strings() {
+        return "'";
     }
 
     @Override
-    public ExpressionBuilder setValue(Value value) {
-        this.value = value;
-        return this;
-    }
+    public String as_identifier(String id) {
+        String quote = this.quote_for_identifiers();
+//        No se porque no esta disponible wrapIfMissing
+//        return StringUtils.wrapIfMissing(id,quote);
+        if (id.startsWith(quote)) {
+            return id;
+        }
+        return quote + id + quote;
 
-    @Override
-    public boolean has_spatial_functions() {
-        return this.config.getBoolean(Config.has_spatial_functions);
     }
 
     @Override
-    public GeometrySupportType geometry_support_type() {
-        return (GeometrySupportType) this.config.get(Config.geometry_type_support);
-    }
-
-    @Override
-    public String string(String s) {
-        String quote = this.config.getString(Config.quote_for_strings);
+    public String as_string(String s) {
+        String quote = this.quote_for_strings();
 //        No se porque no esta disponible wrapIfMissing
-//        return StringUtils.wrapIfMissing(s,quote);
+//        return StringUtils.wrapIfMissing(id,quote);
         if (s.startsWith(quote)) {
             return s;
         }
         return quote + s + quote;
-    }
 
-    @Override
-    public String identifier(String id) {
-        String quote = this.config.getString(Config.quote_for_identifiers);
-//        No se porque no esta disponible wrapIfMissing
-//        return StringUtils.wrapIfMissing(id,quote);
-        if (id.startsWith(quote)) {
-            return id;
-        }
-        return quote + id + quote;
     }
 
     @Override
-    public String bytearray(byte[] data) {
-        return bytearray_0x(data);
+    public String as_string(byte[] data) {
+        return this.expressionBuilder.bytearray_0x(data);
+//        return this.expressionBuilder.bytearray_hex(data);
+//        return this.expressionBuilder.bytearray_x(data);
     }
     
-    public String bytearray_hex(byte[] data) {
-        StringBuilder builder = new StringBuilder();
-        for (byte abyte : data) {
-            int v = abyte & 0xff;
-            builder.append(String.format("%02x", v));
-        }
-        return builder.toString();
-    }
-
-    public String bytearray_0x(byte[] data) {
-        return "0x" + bytearray_hex(data);
-    }
-
-    public String bytearray_x(byte[] data) {
-        return "x'" + bytearray_hex(data) + "'";
-    }
-    
     @Override
-    public Object getSRSId(IProjection projection) {
-        String abrev = projection.getAbrev();
-        return abrev.split(":")[1].trim();
+    public String as_string(boolean value) {
+        return value? "TRUE" : "FALSE";
     }
 
     @Override
-    public Constant srs(IProjection projection) {
-        return constant(getSRSId(projection));
+    public String as_string(Number value) {
+        return Objects.toString(value);
     }
-
-    @Override
-    public Variable variable(String name) {
-        return new VariableBase(name);
-    }
-
-    @Override
-    public Column column(String name) {
-        return new VariableBase(name);
-    }
     
     @Override
-    public Parameter parameter(String name) {
-        Parameters parameters = this.getParameters();
-        Parameter parameter = parameters.get(name);
-        if( parameter != null ) {
-            return parameter;
+    public String as_string(Object value) {
+        if( value == null ) {
+            return "NULL";
         }
-        parameter = this.parameter();
-        parameter.name(name);
-        return parameter;
-    }
-    
-    @Override
-    public Parameter parameter() {
-        return new ParameterBase();
-    }
-    
-    @Override
-    public Constant constant(Object value) {
-        return new ConstantBase(value);
-    }
-
-    @Override
-    public Group group(Value value) {
-        return new GroupBase(value);
-    }
-
-    @Override
-    public GeometryValue geometry(Geometry geom, IProjection projection) {
-        return new GeometryValueBase(geom, projection);
-    }
-
-    @Override
-    public GeometryValue geometry(Geometry geom) {
-        if( geom.getProjection()==null ) {
-            throw new IllegalArgumentException("The geometry does not have an associated projection. Use 'geometry(Geometry, IProjection)'.");
+        if( value instanceof CharSequence ) {
+            return as_string(value.toString());
         }
-        return new GeometryValueBase(geom, geom.getProjection());
-    }
-
-    @Override
-    public GeometryValue envelope(Envelope envelope, IProjection projection) {
-        return new GeometryValueBase(envelope.getGeometry(), projection);
-    }
-
-    @Override
-    public GeometryValue envelope(Envelope envelope) {
-        if( envelope.getProjection()==null ) {
-            throw new IllegalArgumentException("The envelope does not have an associated projection. Use 'envelope(Geometry, IProjection)'.");
+        if( value instanceof Number ) {
+            return as_string((Number)value);
         }
-        return new GeometryValueBase(envelope.getGeometry(), envelope.getProjection());
-    }
-
-    @Override
-    public Custom custom(Object value) {
-        return new CustomBase(value);
-    }
-
-    public Function builtin_function(String name, String format, Value... values) {
-        FunctionBase func = new FunctionBase(name, format);
-        for (Value value : values) {
-            func.parameter(value);
+        if( value instanceof Boolean ) {
+            return as_string((boolean)value);
         }
-        return func;
-    }
-
-    public Function function(String name, Value... values) {
-        FunctionBase func = new FunctionBase(name);
-        for (Value theValue : values) {
-            func.parameter(theValue);
+        if( value instanceof byte[] ) {
+            return as_string((byte[])value);
         }
-        return func;
-    }    
-    
-    public BinaryOperator binaryOperator(String name, String format, Value leftOperand, Value rightOperand) {
-        BinaryOperator operator = new BinaryOperatorBase(name, format);
-        operator.setLeft(leftOperand);
-        operator.setRight(rightOperand);
-        return operator;
+        throw new IllegalArgumentException("Can't support type of value '"+value.getClass().getName()+"'.");
     }
-
+    
     @Override
-    public List<Variable> getVariables() {
-        final Set<Variable> vars = new HashSet<>();
-        this.accept(new Visitor() {
-            @Override
-            public void visit(Visitable value) {
-                vars.add((Variable) value);
-            }
-        }, new ClassVisitorFilter(Variable.class));
-        List<Variable> lvars = new ArrayList<>(vars);
-        Collections.sort(lvars);
-        return lvars;
+    public ExpressionBuilder expression() {
+        return this.expressionBuilder;
     }
 
     @Override
-    public Parameters getParameters() {
-        final Parameters params = new ParametersBase();
-        this.accept(new Visitor() {
-            @Override
-            public void visit(Visitable value) {
-                params.add((Parameter) value);
-            }
-        }, new ClassVisitorFilter(Parameter.class));
-        return params;
+    public boolean has_spatial_functions() {
+        return this.hasSpatialFunctions;
     }
 
     @Override
-    public Function getAsGeometry(Value value) {
-        return builtin_function("ST_AsBinary", config.getString(Config.ST_AsBinary), value);
+    public GeometrySupportType geometry_support_type() {
+        return this.geometrySupportType;
     }
 
-    @Override
-    public ExpressionBuilder set(Value value) {
-        this.value = value;
-        return this;
+    protected ExpressionBuilder createExpressionBuilder() {
+        return ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
     }
 
     @Override
-    public ExpressionBuilder and(Value value) {
-        if (this.value == null) {
-            return this.set(value);
-        }
-        BinaryOperator operator = binaryOperator("AND", config.getString(Config.operator_AND), this.value, value);
-        this.value = operator;
-        return this;
+    public Object srs_id(IProjection projection) {
+        String abrev = projection.getAbrev();
+        return abrev.split(":")[1].trim();
     }
 
     @Override
-    public ExpressionBuilder or(Value value) {
-        if (this.value == null) {
-            return this.set(value);
-        }
-        BinaryOperator operator = binaryOperator("OR", config.getString(Config.operator_OR), this.value, value);
-        this.value = operator;
-        return this;
-    }
-
-    @Override
-    public Function ST_Intersects(Value geom1, Value geom2) {
-        return builtin_function("ST_Intersects", config.getString(Config.ST_Intersects), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_SRID(Value geom) {
-        return builtin_function("ST_SRID", config.getString(Config.ST_SRID), geom);
-    }
-
-    @Override
-    public Function ST_Envelope(Value geom) {
-        return builtin_function("ST_Envelope", config.getString(Config.ST_Envelope), geom);
-    }
-
-    @Override
-    public Function ST_AsText(Value geom) {
-        return builtin_function("ST_AsText", config.getString(Config.ST_AsText), geom);
-    }
-
-    @Override
-    public Function ST_AsBinary(Value geom) {
-        return builtin_function("ST_AsBinary", config.getString(Config.ST_AsBinary), geom);
-    }
-
-    @Override
-    public Function ST_AsEWKB(Value geom) {
-        return builtin_function("ST_AsEWKB", config.getString(Config.ST_AsEWKB), geom);
-    }
-
-    @Override
-    public Function ST_GeomFromText(Value geom, Value crs) {
-        return builtin_function("ST_GeomFromText", config.getString(Config.ST_GeomFromText), geom, crs);
-    }
-
-    @Override
-    public Function ST_GeomFromWKB(Value geom, Value crs) {
-        return builtin_function("ST_GeomFromWKB", config.getString(Config.ST_GeomFromWKB), geom, crs);
-    }
-
-    @Override
-    public Function ST_GeomFromEWKB(Value geom, Value crs) {
-        return builtin_function("ST_GeomFromEWKB", config.getString(Config.ST_GeomFromEWKB), geom, crs);
-    }
-
-    @Override
-    public Function ST_Simplify(Value geom, Value tolerance) {
-        return builtin_function("ST_Simplify", config.getString(Config.ST_Simplify), tolerance);
-    }
-
-    @Override
-    public Function ST_Disjoint(Value geom1, Value geom2) {
-        return builtin_function("ST_Disjoint", config.getString(Config.ST_Disjoint), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_Contains(Value geom1, Value geom2) {
-        return builtin_function("ST_Contains", config.getString(Config.ST_Contains), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_Equals(Value geom1, Value geom2) {
-        return builtin_function("ST_Equals", config.getString(Config.ST_Equals), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_Crosses(Value geom1, Value geom2) {
-        return builtin_function("ST_Crosses", config.getString(Config.ST_Crosses), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_IsClosed(Value geom) {
-        return builtin_function("ST_IsClosed", config.getString(Config.ST_IsClosed), geom);
-    }
-
-    @Override
-    public Function ST_Overlaps(Value geom1, Value geom2) {
-        return builtin_function("ST_Overlaps", config.getString(Config.ST_Overlaps), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_Touches(Value geom1, Value geom2) {
-        return builtin_function("ST_Touches", config.getString(Config.ST_Touches), geom1, geom2);
-    }
-
-    @Override
-    public Function ST_Within(Value geom1, Value geom2) {
-        return builtin_function("ST_Within", config.getString(Config.ST_Within), geom1, geom2);
-    }
-
-    @Override
-    public Function isNull(Value value) {
-        return builtin_function("IS NULL", config.getString(Config.isNull), value);
-    }
-
-    @Override
-    public Function notIsNull(Value value) {
-        return builtin_function("NOT IS NULL", config.getString(Config.notIsNull), value);
-    }
-
-    @Override
-    public Function not(Value value) {
-        return builtin_function("NOT", config.getString(Config.operator_not), value);
-    }
-
-    @Override
-    public Function lcase(Value s) {
-        return builtin_function("LCASE", config.getString(Config.lcase), s);
-    }
-
-    @Override
-    public Function ucase(Value s) {
-        return builtin_function("UCASE", config.getString(Config.ucase), s);
-    }
-
-    @Override
-    public BinaryOperator and(Value leftOperand, Value rightOperand) {
-        return binaryOperator("AND", config.getString(Config.operator_AND), leftOperand, rightOperand);
-    }
-
-    @Override
-    public BinaryOperator or(Value leftOperand, Value rightOperand) {
-        return binaryOperator("OR", config.getString(Config.operator_OR), leftOperand, rightOperand);
-    }
-
-    @Override
-    public BinaryOperator eq(Value leftOperand, Value rightOperand) {
-        return binaryOperator("=", config.getString(Config.operator_EQ), leftOperand, rightOperand);
-    }
-
-    @Override
-    public BinaryOperator ne(Value leftOperand, Value rightOperand) {
-        return binaryOperator("<>", config.getString(Config.operator_NE), leftOperand, rightOperand);
-    }
-
-    @Override
-    public BinaryOperator gt(Value op1, Value op2) {
-        return binaryOperator(">", config.getString(Config.operator_GT), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator ge(Value op1, Value op2) {
-        return binaryOperator(">=", config.getString(Config.operator_GE), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator lt(Value op1, Value op2) {
-        return binaryOperator("<", config.getString(Config.operator_LT), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator le(Value op1, Value op2) {
-        return binaryOperator("<=", config.getString(Config.operator_LE), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator like(Value op1, Value op2) {
-        return binaryOperator("LIKE", config.getString(Config.operator_LIKE), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator ilike(Value op1, Value op2) {
-        return binaryOperator("ILIKE", config.getString(Config.operator_ILIKE), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator add(Value op1, Value op2) {
-        return binaryOperator("ADD", config.getString(Config.operator_add), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator subst(Value op1, Value op2) {
-        return binaryOperator("SUBST", config.getString(Config.operator_subst), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator mult(Value op1, Value op2) {
-        return binaryOperator("MULT", config.getString(Config.operator_mult), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator div(Value op1, Value op2) {
-        return binaryOperator("DIV", config.getString(Config.operator_div), op1, op2);
-    }
-
-    @Override
-    public BinaryOperator concat(Value op1, Value op2) {
-        return binaryOperator("CONCAT", config.getString(Config.operator_concat), op1, op2);
-    }
- 
-    @Override
     public String default_schema() {
-        return config.getString(SQLConfig.default_schema);
+        return this.defaultSchema;
     }
 
     @Override
-    public boolean supportSchemas() {
-        return config.getBoolean(Config.support_schemas);
+    public boolean support_schemas() {
+        return this.supportSchemas;
     }
-    
-    @Override
-    @Deprecated
-    public String sqltype(int type, int p, int s) {
-        return this.sqltype(type, p, s, Geometry.TYPES.GEOMETRY, Geometry.SUBTYPES.UNKNOWN);
-    }
 
     @Override
     public String sqltype(int type, int p, int s, int geomType, int geomSubtype) {
         switch (type) {
             case DataTypes.BOOLEAN:
-                return config.getString(SQLConfig.type_boolean);
+                return type_boolean;
             case DataTypes.BYTE:
-                return config.getString(SQLConfig.type_byte);
+                return type_byte;
             case DataTypes.BYTEARRAY:
-                return config.getString(SQLConfig.type_bytearray);
+                return type_bytearray;
             case DataTypes.GEOMETRY:
-                return config.getString(SQLConfig.type_geometry);
+                return type_geometry;
             case DataTypes.CHAR:
-                return config.getString(SQLConfig.type_char);
+                return type_char;
             case DataTypes.DATE:
-                return config.getString(SQLConfig.type_date);
+                return type_date;
             case DataTypes.DOUBLE:
-                  // FIXME: Si cargamos la capa "country" al exportarla a
-                  // SQLServer falla por:
-                  //  Error de desbordamiento aritmético al convertir float al tipo de datos numeric.
-                  // Al parecer la capa declara la columna sqkm_ctry como Numeric(12,6) y para 
-                  // Algeria intenta asignarle un valor de 2320972.0 y falla.
-                  // Habria que repasar el proveedor de shape.
-                
+                // FIXME: Si cargamos la capa "country" al exportarla a
+                // SQLServer falla por:
+                //  Error de desbordamiento aritmético al convertir float al tipo de datos numeric.
+                // Al parecer la capa declara la columna sqkm_ctry como Numeric(12,6) y para 
+                // Algeria intenta asignarle un valor de 2320972.0 y falla.
+                // Habria que repasar el proveedor de shape.
+
 //                if (p > 1) {
 //                    if (s < 0) {
 //                        return MessageFormat.format(config.getString(SQLConfig.type_numeric_p), p);
 //                    }
 //                    return MessageFormat.format(config.getString(SQLConfig.type_numeric_ps), p,s);
 //                }
-                return MessageFormat.format(config.getString(SQLConfig.type_double),p,s);
+                return MessageFormat.format(type_double, p, s);
             case DataTypes.BIGDECIMAL:
                 if (p < 1) {
                     p = 20;
